org.apache.xml.dtm.ref.dom2dtm

## Class DOM2DTM

- java.lang.Object
- - org.apache.xml.dtm.ref.DTMDefaultBase
  - - org.apache.xml.dtm.ref.DTMDefaultBaseTraversers
    - - org.apache.xml.dtm.ref.DTMDefaultBaseIterators
      - - org.apache.xml.dtm.ref.dom2dtm.DOM2DTM

- All Implemented Interfaces:
    DTM

      public class DOM2DTM
      extends DTMDefaultBaseIterators

  The `DOM2DTM` class serves up a DOM's contents via the DTM API. Note that it doesn't necessarily represent a full Document tree. You can wrap a DOM2DTM around a specific node and its subtree and the right things should happen. (I don't _think_ we currently support DocumentFrgment nodes as roots, though that might be worth considering.) Note too that we do not currently attempt to track document mutation. If you alter the DOM after wrapping DOM2DTM around it, all bets are off.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `DOM2DTM.CharacterNodeHandler`

    - ### Nested classes/interfaces inherited from class org.apache.xml.dtm.ref.DTMDefaultBaseIterators

      `DTMDefaultBaseIterators.AncestorIterator, DTMDefaultBaseIterators.AttributeIterator, DTMDefaultBaseIterators.ChildrenIterator, DTMDefaultBaseIterators.DescendantIterator, DTMDefaultBaseIterators.FollowingIterator, DTMDefaultBaseIterators.FollowingSiblingIterator, DTMDefaultBaseIterators.InternalAxisIteratorBase, DTMDefaultBaseIterators.NamespaceAttributeIterator, DTMDefaultBaseIterators.NamespaceChildrenIterator, DTMDefaultBaseIterators.NamespaceIterator, DTMDefaultBaseIterators.NthDescendantIterator, DTMDefaultBaseIterators.ParentIterator, DTMDefaultBaseIterators.PrecedingIterator, DTMDefaultBaseIterators.PrecedingSiblingIterator, DTMDefaultBaseIterators.RootIterator, DTMDefaultBaseIterators.SingletonIterator, DTMDefaultBaseIterators.TypedAncestorIterator, DTMDefaultBaseIterators.TypedAttributeIterator, DTMDefaultBaseIterators.TypedChildrenIterator, DTMDefaultBaseIterators.TypedDescendantIterator, DTMDefaultBaseIterators.TypedFollowingIterator, DTMDefaultBaseIterators.TypedFollowingSiblingIterator, DTMDefaultBaseIterators.TypedNamespaceIterator, DTMDefaultBaseIterators.TypedPrecedingIterator, DTMDefaultBaseIterators.TypedPrecedingSiblingIterator, DTMDefaultBaseIterators.TypedRootIterator, DTMDefaultBaseIterators.TypedSingletonIterator`

  - ### Field Summary

    - ### Fields inherited from class org.apache.xml.dtm.ref.DTMDefaultBase

      `DEFAULT_BLOCKSIZE, DEFAULT_NUMBLOCKS, DEFAULT_NUMBLOCKS_SMALL, m_mgr, ROOTNODE`

    - ### Fields inherited from interface org.apache.xml.dtm.DTM

      `ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NAMESPACE_NODE, NOTATION_NODE, NTYPES, NULL, PROCESSING_INSTRUCTION_NODE, ROOT_NODE, TEXT_NODE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DOM2DTM(DTMManager mgr, javax.xml.transform.dom.DOMSource domSource, int dtmIdentity, DTMWSFilter whiteSpaceFilter, XMLStringFactory xstringfactory, boolean doIndexing)` Construct a DOM2DTM object from a DOM node.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `dispatchCharactersEvents(int nodeHandle, org.xml.sax.ContentHandler ch, boolean normalize)` Directly call the characters method on the passed ContentHandler for the string-value of the given node (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value).
    `void` | `dispatchToEvents(int nodeHandle, org.xml.sax.ContentHandler ch)` Directly create SAX parser events from a subtree.
    `int` | `getAttributeNode(int nodeHandle, java.lang.String namespaceURI, java.lang.String name)` Retrieves an attribute node by by qualified name and namespace URI.
    `org.xml.sax.ContentHandler` | `getContentHandler()` getContentHandler returns "our SAX builder" -- the thing that someone else should send SAX events to in order to extend this DTM model.
    `org.xml.sax.ext.DeclHandler` | `getDeclHandler()` Return this DTM's DeclHandler.
    `java.lang.String` | `getDocumentTypeDeclarationPublicIdentifier()` Return the public identifier of the external subset, normalized as described in 4.2.2 External Entities [XML].
    `java.lang.String` | `getDocumentTypeDeclarationSystemIdentifier()` A document type declaration information item has the following properties: 1.
    `org.xml.sax.DTDHandler` | `getDTDHandler()` Return this DTM's DTDHandler.
    `int` | `getElementById(java.lang.String elementId)` Returns the `Element` whose `ID` is given by `elementId`.
    `org.xml.sax.EntityResolver` | `getEntityResolver()` Return this DTM's EntityResolver.
    `org.xml.sax.ErrorHandler` | `getErrorHandler()` Return this DTM's ErrorHandler.
    `int` | `getHandleOfNode(org.w3c.dom.Node node)` Get the handle from a Node.
    `org.xml.sax.ext.LexicalHandler` | `getLexicalHandler()` Return this DTM's lexical handler.
    `java.lang.String` | `getLocalName(int nodeHandle)` Given a node handle, return its XPath-style localname.
    `java.lang.String` | `getNamespaceURI(int nodeHandle)` Given a node handle, return its DOM-style namespace URI (As defined in Namespaces, this is the declared URI which this node's prefix -- or default in lieu thereof -- was mapped to.)
    `org.w3c.dom.Node` | `getNode(int nodeHandle)` Return an DOM node for the given node.
    `java.lang.String` | `getNodeName(int nodeHandle)` Given a node handle, return its DOM-style node name.
    `java.lang.String` | `getNodeNameX(int nodeHandle)` Given a node handle, return the XPath node name.
    `java.lang.String` | `getNodeValue(int nodeHandle)` Given a node handle, return its node value.
    `int` | `getNumberOfNodes()` Get the number of nodes that have been added.
    `java.lang.String` | `getPrefix(int nodeHandle)` Given a namespace handle, return the prefix that the namespace decl is mapping.
    `javax.xml.transform.SourceLocator` | `getSourceLocatorFor(int node)` No source information is available for DOM2DTM, so return `null` here.
    `XMLString` | `getStringValue(int nodeHandle)` Get the string-value of a node as a String object (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value).
    `java.lang.String` | `getUnparsedEntityURI(java.lang.String name)` The getUnparsedEntityURI function returns the URI of the unparsed entity with the specified name in the same document as the context node (see [3.3 Unparsed Entities]).
    `boolean` | `isAttributeSpecified(int attributeHandle)` 5.
    `boolean` | `isWhitespace(int nodeHandle)` Determine if the string-value of a node is whitespace
    `boolean` | `needsTwoThreads()`
    `void` | `setIncrementalSAXSource(IncrementalSAXSource source)` Bind an IncrementalSAXSource to this DTM.
    `void` | `setProperty(java.lang.String property, java.lang.Object value)` For the moment all the run time properties are ignored by this class.

    - ### Methods inherited from class org.apache.xml.dtm.ref.DTMDefaultBaseIterators

      `getAxisIterator, getTypedAxisIterator`

    - ### Methods inherited from class org.apache.xml.dtm.ref.DTMDefaultBaseTraversers

      `getAxisTraverser`

    - ### Methods inherited from class org.apache.xml.dtm.ref.DTMDefaultBase

      `appendChild, appendTextChild, documentRegistration, documentRelease, dumpDTM, dumpNode, getDocument, getDocumentAllDeclarationsProcessed, getDocumentBaseURI, getDocumentEncoding, getDocumentRoot, getDocumentStandalone, getDocumentSystemIdentifier, getDocumentVersion, getDTMIDs, getExpandedTypeID, getExpandedTypeID, getFirstAttribute, getFirstChild, getFirstNamespaceNode, getLastChild, getLevel, getLocalNameFromExpandedNameID, getManager, getNamespaceFromExpandedNameID, getNamespaceType, getNextAttribute, getNextNamespaceNode, getNextSibling, getNodeHandle, getNodeIdent, getNodeType, getOwnerDocument, getParent, getPreviousSibling, getStringValueChunk, getStringValueChunkCount, getTypedFirstChild, getTypedNextSibling, hasChildNodes, isCharacterElementContentWhitespace, isDocumentAllDeclarationsProcessed, isNodeAfter, isSupported, makeNodeHandle, makeNodeIdentity, migrateTo, setDocumentBaseURI, setFeature, supportsPreStripping`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DOM2DTM

          public DOM2DTM(DTMManager mgr,
                         javax.xml.transform.dom.DOMSource domSource,
                         int dtmIdentity,
                         DTMWSFilter whiteSpaceFilter,
                         XMLStringFactory xstringfactory,
                         boolean doIndexing)

      Construct a DOM2DTM object from a DOM node.
      Parameters:
        `mgr` - The DTMManager who owns this DTM.
        `domSource` - the DOM source that this DTM will wrap.
        `dtmIdentity` - The DTM identity ID for this DTM.
        `whiteSpaceFilter` - The white space filter for this DTM, which may be null.
        `xstringfactory` - XMLString factory for creating character content.
        `doIndexing` - true if the caller considers it worth it to use indexing schemes.

  - ### Method Detail

    - #### getNumberOfNodes

          public int getNumberOfNodes()

      Get the number of nodes that have been added.
      Returns:
        the number of nodes that have been mapped.

    - #### getNode

          public org.w3c.dom.Node getNode(int nodeHandle)

      Return an DOM node for the given node.
      Specified by:
        `getNode` in interface `DTM`
      Overrides:
        `getNode` in class `DTMDefaultBase`
      Parameters:
        `nodeHandle` - The node ID.
      Returns:
        A node representation of the DTM node.

    - #### getHandleOfNode

          public int getHandleOfNode(org.w3c.dom.Node node)

      Get the handle from a Node. This is a more robust version of getHandleFromNode, intended to be usable by the public.

      %OPT% This will be pretty slow.

      %REVIEW% This relies on being able to test node-identity via object-identity. DTM2DOM proxying is a great example of a case where that doesn't work. DOM Level 3 will provide the isSameNode() method to fix that, but until then this is going to be flaky.
      Parameters:
        `node` - A node, which may be null.
      Returns:
        The node handle or `DTM.NULL`.

    - #### getAttributeNode

          public int getAttributeNode(int nodeHandle,
                                      java.lang.String namespaceURI,
                                      java.lang.String name)

      Retrieves an attribute node by by qualified name and namespace URI.
      Specified by:
        `getAttributeNode` in interface `DTM`
      Specified by:
        `getAttributeNode` in class `DTMDefaultBase`
      Parameters:
        `nodeHandle` - int Handle of the node upon which to look up this attribute..
        `namespaceURI` - The namespace URI of the attribute to retrieve, or null.
        `name` - The local name of the attribute to retrieve.
      Returns:
        The attribute node handle with the specified name ( `nodeName`) or `DTM.NULL` if there is no such attribute.

    - #### getStringValue

          public XMLString getStringValue(int nodeHandle)

      Get the string-value of a node as a String object (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value).
      Specified by:
        `getStringValue` in interface `DTM`
      Specified by:
        `getStringValue` in class `DTMDefaultBase`
      Parameters:
        `nodeHandle` - The node ID.
      Returns:
        A string object that represents the string-value of the given node.

    - #### isWhitespace

          public boolean isWhitespace(int nodeHandle)

      Determine if the string-value of a node is whitespace
      Parameters:
        `nodeHandle` - The node Handle.
      Returns:
        Return true if the given node is whitespace.

    - #### getNodeName

          public java.lang.String getNodeName(int nodeHandle)

      Given a node handle, return its DOM-style node name. This will include names such as #text or #document.
      Specified by:
        `getNodeName` in interface `DTM`
      Specified by:
        `getNodeName` in class `DTMDefaultBase`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String Name of this node, which may be an empty string. %REVIEW% Document when empty string is possible... %REVIEW-COMMENT% It should never be empty, should it?

    - #### getNodeNameX

          public java.lang.String getNodeNameX(int nodeHandle)

      Given a node handle, return the XPath node name. This should be the name as described by the XPath data model, NOT the DOM-style name.
      Specified by:
        `getNodeNameX` in interface `DTM`
      Overrides:
        `getNodeNameX` in class `DTMDefaultBase`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String Name of this node, which may be an empty string.

    - #### getLocalName

          public java.lang.String getLocalName(int nodeHandle)

      Given a node handle, return its XPath-style localname. (As defined in Namespaces, this is the portion of the name after any colon character).
      Specified by:
        `getLocalName` in interface `DTM`
      Specified by:
        `getLocalName` in class `DTMDefaultBase`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String Local name of this node.

    - #### getPrefix

          public java.lang.String getPrefix(int nodeHandle)

      Given a namespace handle, return the prefix that the namespace decl is mapping. Given a node handle, return the prefix used to map to the namespace.

      %REVIEW% Are you sure you want "" for no prefix?

      %REVIEW-COMMENT% I think so... not totally sure. -sb

      Specified by:
        `getPrefix` in interface `DTM`
      Specified by:
        `getPrefix` in class `DTMDefaultBase`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String prefix of this node's name, or "" if no explicit namespace prefix was given.

    - #### getNamespaceURI

          public java.lang.String getNamespaceURI(int nodeHandle)

      Given a node handle, return its DOM-style namespace URI (As defined in Namespaces, this is the declared URI which this node's prefix -- or default in lieu thereof -- was mapped to.)

      %REVIEW% Null or ""? -sb

      Specified by:
        `getNamespaceURI` in interface `DTM`
      Specified by:
        `getNamespaceURI` in class `DTMDefaultBase`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String URI value of this node's namespace, or null if no namespace was resolved.

    - #### getNodeValue

          public java.lang.String getNodeValue(int nodeHandle)

      Given a node handle, return its node value. This is mostly as defined by the DOM, but may ignore some conveniences.

      Specified by:
        `getNodeValue` in interface `DTM`
      Specified by:
        `getNodeValue` in class `DTMDefaultBase`
      Parameters:
        `nodeHandle` - The node id.
      Returns:
        String Value of this node, or null if not meaningful for this node type.

    - #### getDocumentTypeDeclarationSystemIdentifier

          public java.lang.String getDocumentTypeDeclarationSystemIdentifier()

      A document type declaration information item has the following properties: 1. [system identifier] The system identifier of the external subset, if it exists. Otherwise this property has no value.
      Specified by:
        `getDocumentTypeDeclarationSystemIdentifier` in interface `DTM`
      Specified by:
        `getDocumentTypeDeclarationSystemIdentifier` in class `DTMDefaultBase`
      Returns:
        the system identifier String object, or null if there is none.

    - #### getDocumentTypeDeclarationPublicIdentifier

          public java.lang.String getDocumentTypeDeclarationPublicIdentifier()

      Return the public identifier of the external subset, normalized as described in 4.2.2 External Entities [XML]. If there is no external subset or if it has no public identifier, this property has no value.
      Specified by:
        `getDocumentTypeDeclarationPublicIdentifier` in interface `DTM`
      Specified by:
        `getDocumentTypeDeclarationPublicIdentifier` in class `DTMDefaultBase`
      Returns:
        the public identifier String object, or null if there is none.

    - #### getElementById

          public int getElementById(java.lang.String elementId)

      Returns the `Element` whose `ID` is given by `elementId`. If no such element exists, returns `DTM.NULL`. Behavior is not defined if more than one element has this `ID`. Attributes (including those with the name "ID") are not of type ID unless so defined by DTD/Schema information available to the DTM implementation. Implementations that do not know whether attributes are of type ID or not are expected to return `DTM.NULL`.

      %REVIEW% Presumably IDs are still scoped to a single document, and this operation searches only within a single document, right? Wouldn't want collisions between DTMs in the same process.

      Specified by:
        `getElementById` in interface `DTM`
      Specified by:
        `getElementById` in class `DTMDefaultBase`
      Parameters:
        `elementId` - The unique `id` value for an element.
      Returns:
        The handle of the matching element.

    - #### getUnparsedEntityURI

          public java.lang.String getUnparsedEntityURI(java.lang.String name)

      The getUnparsedEntityURI function returns the URI of the unparsed entity with the specified name in the same document as the context node (see [3.3 Unparsed Entities]). It returns the empty string if there is no such entity.

      XML processors may choose to use the System Identifier (if one is provided) to resolve the entity, rather than the URI in the Public Identifier. The details are dependent on the processor, and we would have to support some form of plug-in resolver to handle this properly. Currently, we simply return the System Identifier if present, and hope that it a usable URI or that our caller can map it to one. TODO: Resolve Public Identifiers... or consider changing function name.

      If we find a relative URI reference, XML expects it to be resolved in terms of the base URI of the document. The DOM doesn't do that for us, and it isn't entirely clear whether that should be done here; currently that's pushed up to a higher level of our application. (Note that DOM Level 1 didn't store the document's base URI.) TODO: Consider resolving Relative URIs.

      (The DOM's statement that "An XML processor may choose to completely expand entities before the structure model is passed to the DOM" refers only to parsed entities, not unparsed, and hence doesn't affect this function.)

      Specified by:
        `getUnparsedEntityURI` in interface `DTM`
      Specified by:
        `getUnparsedEntityURI` in class `DTMDefaultBase`
      Parameters:
        `name` - A string containing the Entity Name of the unparsed entity.
      Returns:
        String containing the URI of the Unparsed Entity, or an empty string if no such entity exists.

    - #### isAttributeSpecified

          public boolean isAttributeSpecified(int attributeHandle)

      5. [specified] A flag indicating whether this attribute was actually specified in the start-tag of its element, or was defaulted from the DTD.
      Specified by:
        `isAttributeSpecified` in interface `DTM`
      Specified by:
        `isAttributeSpecified` in class `DTMDefaultBase`
      Parameters:
        `attributeHandle` - the attribute handle
      Returns:
        `true` if the attribute was specified; `false` if it was defaulted.

    - #### setIncrementalSAXSource

          public void setIncrementalSAXSource(IncrementalSAXSource source)

      Bind an IncrementalSAXSource to this DTM. NOT RELEVANT for DOM2DTM, since we're wrapped around an existing DOM.
      Parameters:
        `source` - The IncrementalSAXSource that we want to recieve events from on demand.

    - #### getContentHandler

          public org.xml.sax.ContentHandler getContentHandler()

      getContentHandler returns "our SAX builder" -- the thing that someone else should send SAX events to in order to extend this DTM model.
      Returns:
        null if this model doesn't respond to SAX events, "this" if the DTM object has a built-in SAX ContentHandler, the IncrmentalSAXSource if we're bound to one and should receive the SAX stream via it for incremental build purposes...

    - #### getLexicalHandler

          public org.xml.sax.ext.LexicalHandler getLexicalHandler()

      Return this DTM's lexical handler. %REVIEW% Should this return null if constrution already done/begun?
      Returns:
        null if this model doesn't respond to lexical SAX events, "this" if the DTM object has a built-in SAX ContentHandler, the IncrementalSAXSource if we're bound to one and should receive the SAX stream via it for incremental build purposes...

    - #### getEntityResolver

          public org.xml.sax.EntityResolver getEntityResolver()

      Return this DTM's EntityResolver.
      Returns:
        null if this model doesn't respond to SAX entity ref events.

    - #### getDTDHandler

          public org.xml.sax.DTDHandler getDTDHandler()

      Return this DTM's DTDHandler.
      Returns:
        null if this model doesn't respond to SAX dtd events.

    - #### getErrorHandler

          public org.xml.sax.ErrorHandler getErrorHandler()

      Return this DTM's ErrorHandler.
      Returns:
        null if this model doesn't respond to SAX error events.

    - #### getDeclHandler

          public org.xml.sax.ext.DeclHandler getDeclHandler()

      Return this DTM's DeclHandler.
      Returns:
        null if this model doesn't respond to SAX Decl events.

    - #### needsTwoThreads

          public boolean needsTwoThreads()

      Returns:
        true iff we're building this model incrementally (eg we're partnered with a IncrementalSAXSource) and thus require that the transformation and the parse run simultaneously. Guidance to the DTMManager.

    - #### dispatchCharactersEvents

          public void dispatchCharactersEvents(int nodeHandle,
                                               org.xml.sax.ContentHandler ch,
                                               boolean normalize)
                                        throws org.xml.sax.SAXException

      Directly call the characters method on the passed ContentHandler for the string-value of the given node (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value). Multiple calls to the ContentHandler's characters methods may well occur for a single call to this method.
      Specified by:
        `dispatchCharactersEvents` in interface `DTM`
      Specified by:
        `dispatchCharactersEvents` in class `DTMDefaultBase`
      Parameters:
        `nodeHandle` - The node ID.
        `ch` - A non-null reference to a ContentHandler.
        `normalize` - true if the content should be normalized according to the rules for the XPath normalize-space function.
      Throws:
        `org.xml.sax.SAXException`

    - #### dispatchToEvents

          public void dispatchToEvents(int nodeHandle,
                                       org.xml.sax.ContentHandler ch)
                                throws org.xml.sax.SAXException

      Directly create SAX parser events from a subtree.
      Specified by:
        `dispatchToEvents` in interface `DTM`
      Specified by:
        `dispatchToEvents` in class `DTMDefaultBase`
      Parameters:
        `nodeHandle` - The node ID.
        `ch` - A non-null reference to a ContentHandler.
      Throws:
        `org.xml.sax.SAXException`

    - #### setProperty

          public void setProperty(java.lang.String property,
                                  java.lang.Object value)

      For the moment all the run time properties are ignored by this class.
      Parameters:
        `property` - a `String` value
        `value` - an `Object` value

    - #### getSourceLocatorFor

          public javax.xml.transform.SourceLocator getSourceLocatorFor(int node)

      No source information is available for DOM2DTM, so return `null` here.
      Parameters:
        `node` - an `int` value
      Returns:
        null

Copyright © 2023 Apache XML Project. All Rights Reserved.